/*
 *******************************************************
  
 cat and mice benchmark, wodes08, libfaudes 2.09

 this file provides models for individual maze levels of the cat-and-mouse
 tower described in the benchmark example. In each level, the number of 
 cats/mice that are present in each room is described. Hence, in this model,
 it is not envisaged to distinguish individual cats and mice. 
  
 *******************************************************
 */ 


#include "libfaudes.h"

using namespace faudes;

// simple protocol switch
#ifdef FAUDES_DEBUG_WODES08
#define FD_DW08(message) std::cerr << "FAUDES_WODES: " <<  message << std::endl;
#else
#define FD_DW08(message)
#endif

// This function creates the maze level l (rMaze) and its local safety specification (rMazeSpec) considering
// that the overall cat-and-mouse tower has n levels and k cats/mice are present. Additionally, the initial high-level
// alphabet for a potential hierarchical abstraction is determined as the set of shared events with other maze levels.
void Maze(cGenerator& rMaze, cGenerator& rMazeSpec, const int n, const int k, const int l, EventSet& rHighAlphabet);

